 鲜花( 0)  鸡蛋( 0)
|
动态规划的基本思想是将待求解问题分解成若干个子问题,先求解子问题,并将这些子问题的解保存起来,如果以后在求解较大子问题的时候需要用到这些子问题的解,就可以直接取出这些已经计算过的解而免去重复运算。保存子问题的解可以使用填表方式,例如保存在数组中。
/ ?9 u, D D0 u2 Q. B4 @7 D; J 用一个实际例子来体现动态规划的算法思想——硬币找零问题。
0 }1 f7 j( d* h 硬币找零问题描述:现存在一堆面值为 V1、V2、V3 … 个单位的硬币,问最少需要多少个硬币才能找出总值为 T 个单位的零钱?假设这一堆面值分别为 1、2、5、21、25 元,需要找出总值 T 为 63 元的零钱。% m. i \$ x' d a' {
很明显,只要拿出 3 个 21 元的硬币就凑够了 63 元了。7 Q: W/ c" P# ?& U
基于上述动态规划的思想,我们可以从 1 元开始计算出最少需要几个硬币,然后再求 2 元、3元…每一次求得的结果都保存在一个数组中,以后需要用到时则直接取出即可。那么我们什么时候需要这些子问题的解呢?如何体现出由子问题的解得到较大问题的解呢?
8 x; W# N' I& ~4 _1 ~ 其实,在我们从 1 元开始依次找零时,可以尝试一下当前要找零的面值(这里指 1 元)是否能够被分解成另一个已求解的面值的找零需要的硬币个数再加上这一堆硬币中的某个面值之和,如果这样分解之后最终的硬币数是最少的,那么问题就得到答案了。
$ o$ ~4 }- E' I" {' i9 R 单是上面的文字描述太抽象,先假定以下变量:
; `9 Q% o$ L+ u+ k+ f. U values[] : 保存每一种硬币的币值的数组% q0 b1 N7 H: H6 O; |+ b
valueKinds :币值不同的硬币种类数量,即values[]数组的大小
6 _ o2 G: l. c, @" I% G money : 需要找零的面值
: |& m5 g8 X D: r _ coiUsed[] : 保存面值为 i 的纸币找零所需的最小硬币数* n1 L/ t. @7 P4 @
算法描述:
9 J" f2 T: g3 U8 y( ]( f4 w: f 当求解总面值为 i 的找零最少硬币数 coiUsed[ i ] 时,将其分解成求解 coiUsed[ i – cents]和一个面值为 cents 元的硬币,由于 i – cents < i , 其解 coiUsed[ i – cents] 已经存在,如果面值为 cents 的硬币满足题意,那么最终解 coiUsed[ i ] 则等于 coiUsed[ i – cents] 再加上 1(即面值为 cents)的这一个硬币。) B7 U/ [7 M! L* Z
下面用代码实现并测试一下:
7 h& W# j6 X- p$ p0 i! j public class CoiChange {5 |. f$ i% U% ^( A
/**5 c* j# {9 `# Y& G L; q
* 硬币找零:动态规划算法
$ a5 {+ o# Q) n *
( {) C; K% O' `* }0 U * @param values% y& }$ E! {0 q' e
* :保存每一种硬币的币值的数组( I+ d) C/ @) b. H% O
* @param valueKinds* S' P% i6 A7 L5 N+ ^ Z
* :币值不同的硬币种类数量,即coinValue[]数组的大小
. F& [4 H: u! D! j& z5 C5 O * @param money
n* g% V' m3 F. ]+ k * :需要找零的面值# W. l: D: ^3 @9 g2 n3 P2 z
* @param coiUsed
' a5 w* F9 h; t" K- N" I * :保存面值为i的纸币找零所需的最小硬币数8 `+ |/ M$ g- Q+ k. O& ?
*/+ I) U$ O: ]! [* k2 G
public static void makeChange(int[] values, int valueKinds, int money,+ z v5 |5 q/ \# g
int[] coiUsed) {1 s J4 J$ q5 o. A) o, {* g4 x9 U
coiUsed[0] = 0;1 R, I5 j: j* J w* |( P1 f( ?
// 对每一分钱都找零,即保存子问题的解以备用,即填表
/ F! ?. f: X# w for (int cents = 1; cents <= money; cents++) {
1 v# k2 s, Q9 N% X w8 A+ r) k // 当用最小币值的硬币找零时,所需硬币数量最多0 o/ }3 \: [3 |* v- B
int minCoi = cents;. H/ i% T" b7 j4 w5 c
// 遍历每一种面值的硬币,看是否可作为找零的其中之一$ {; G" x- D8 x+ Z, m, M
for (int kind = 0; kind < valueKinds; kind++) {
9 m* S% Z1 K7 G8 T // 若当前面值的硬币小于当前的cents则分解问题并查表& n+ y' U1 M, n6 `( |; Q
if (values[kind] <= cents) {3 I6 m6 P9 M; x& `( p
int temp = coiUsed[cents - values[kind]] + 1;4 j( n$ A2 n" D+ t- H
if (temp < minCoi) {! `% B6 [7 W) [) r0 @- ^, y
minCoi = temp;8 a! f) B5 K% L5 J
}
1 t" X- r! u6 c }$ X* K4 \+ \( r3 V4 b
}( q5 ]( I) j/ b0 N
// 保存最小硬币数$ i) J5 N0 X0 Y, t0 {* n) F! V
coiUsed[cents] = minCoi;
2 ], F4 m0 y6 E- y System.out.println("面值为 " + (cents) + " 的最小硬币数 : "! r& N7 u& s% t# D6 S7 M! F
+ coiUsed[cents]);
, z" h3 }4 z2 E }; M' \+ r: o2 M5 H) B2 R- W" M
}0 H% F. Y8 H0 P" \+ g: \4 G
public static void main(String[] args) {0 \$ Z9 P/ j/ r; C" R. }$ M
// 硬币面值预先已经按降序排列- f6 S, K3 v7 \3 N( o; e* q, B! h
int[] coinValue = new int[] { 25, 21, 10, 5, 1 };
) C r M% ?8 Q, `1 w // 需要找零的面值
a8 j0 W' c* V& F int money = 63;+ }4 c3 t, [+ n6 j
// 保存每一个面值找零所需的最小硬币数,0号单元舍弃不用,所以要多加1, i# n" r% Q; B) g
int[] coiUsed = new int[money + 1];
) v' E: {# x& w5 }4 n makeChange(coinValue, coinValue.length, money, coiUsed);
6 v! q& y! W/ a7 }( v4 g }
* ~! F! U4 Y; d5 l5 W) {- h }" N- d) G" m& z; X
测试结果:
3 L. i7 ^4 Y" ?- G 面值为 1 的最小硬币数 : 1 面值为 2 的最小硬币数 : 2 面值为 3 的最小硬币数 : 3 面值为 4 的最小硬币数 : 4 面值为 5 的最小硬币数 : 1 面值为 6 的最小硬币数 : 2 ... ... 面值为 60 的最小硬币数 : 3 面值为 61 的最小硬币数 : 4 面值为 62 的最小硬币数 : 4 面值为 63 的最小硬币数 : 3
8 e2 b" b7 t' {. C0 ?$ U8 a 上面的代码并没有给出具体应该是哪几个面值的硬币,这个可以再使用一些数组保存而打印出来。) V) D! w& ~; n O% ^9 P2 y# d
参考lovebeyond19831993.blog.163.com/blog/static/131811444201101901819833/" W H G) O* g7 O% G
问题: c" k5 ~4 L0 V( I! A( J
假设有n种面值不同的硬币,个个面值存于数组T[1:n]中,现在用这些硬币来找钱,各种硬币的使用个数不限;4 \: ^4 W0 r) G$ r
求对于给定的钱数N,最少可以由几枚硬币组成,并输出硬币序列。 T( [* q8 a& }1 R) Q; x
分析:
! K' {* A' C g" O/ m 假设对于i = 1...N-1, 所需最少的硬币数Count(i) 已知, 那么对于N,所需的硬币数为Min( Count(i) + Count(N-i)) , i=1...N-1;
* g1 } q+ ? A/ e 于是一个直观的方法是用递归计算。4 l, h0 O4 e( z1 ~: K& `8 O
但是,递归过程中,每次计算Count(i),都会重复计算 Count(1)....Count(i-1); 这样时间复杂度就是O(N2);1 s" m" {7 _4 D! O! c4 \
事实上,这是一个典型的动态规划问题,我们可以从1开始记录下每个钱数所需的硬币枚数,避免重复计算,为了能够输出硬币序列,我们还需要记录下每次新加入的硬币。3 W& e3 l. s! \# v- i
下面给出用动态规划解决此问题的递推式:
k( y) v# M9 Y) ]1 j/ W, g 参数说明: 当只用面值为T[1],T[2],…T[n]来找出钱j时,所用的硬币的最小个数记为C(i,j),则C(i,j)的递推方程为: U$ f9 e( i+ c% t
算法设计:
. M7 I0 r; y( E0 R v" _3 u; l #include <iostream>
' B- | E: |/ L% @2 S; a using namespace std;& T, ^+ \5 y+ `% i! r6 O
int min_number_of_stamps(cot int* array, size_t array_size, int request) {
& c% e- O; E' P* P if (array == NULL || array_size <= 0 || request < 1) {4 w. |! s: R# c% [
return -1;; {2 H3 N/ l; W$ Q. X
}
4 n& W; X, f. f7 Q* {' x int* numofStamps = new int[request + 1];
( \) I5 s6 E, J6 f numofStamps[0] = 0;
& s1 M# i5 g* | e% C7 p3 m for(int i = 1; i <= request; i++){ d l" s1 l: b4 \
int cn = i;3 j+ f; f/ l0 ~% s& a# k
for(size_t j = 0; j < array_size; j++){( E. O! h, e& y
if(array[j] <= i){
7 H+ Z9 m1 G8 F# Z/ A G int tmp = numofStamps[i - array[j]] + 1;
' r6 ]# e' @9 U6 k: J0 B if(tmp < cn)
_( N6 {, n, \9 K4 a8 a$ c cn = tmp;0 ^6 u1 ?7 w8 |5 x& b! g3 x
}
% I @: ^: ~% I( ?7 t$ K6 w0 s5 y }
$ }* f2 |4 ~. ^6 e$ Y0 z: W) s numofStamps[i] = cn;. u. j, q3 l! q8 p4 E8 D
}4 G1 k1 {% @3 z2 C$ ?
int t = numofStamps[request];: a* j2 f8 x; _. R# T( A
delete[] numofStamps;
, }$ }3 F0 r7 [5 y$ y' I2 ` return t;# y: \& Q9 ?4 N* N
}
# h, Q0 t# \7 r' g9 Y/ } int main() {
2 h( G J8 x1 g, I0 k int array[] = { 90, 30, 24, 15, 12, 10, 5, 3, 2, 1 };9 M# e2 n- b) t0 G/ c5 {* g
int array_size = sizeof(array) / sizeof(int);; `7 m$ ?+ }+ y$ K& W7 o
int t = min_number_of_stamps(array, array_size, 32);
- Z7 o8 M' s. `. @+ n cout << t << endl;! Y3 E1 k& o* V6 D
}
* s5 \8 R b" I* u |
|